from fuzzySet import *
def evalFuzzy(A,V):#■V(0～100)に対するファジー集合
    TA=A[int(V)];F=[0.0 for i in range(101)]
    for i in range(101):
        if A[i]>TA: F[i]=TA
        else:F[i]=A[i]
    return F
def Gravity(A):#■重心位置を求める(結果は0.0～1.0)
    T=0;D=0
    for i in range(101):
        T+=A[i]*float(i)/100;D+=A[i]
    return T/D
def drawGravity(canvas,G):#■重心位置をグラフに表示
    X=G*400+30;print(X,G)
    canvas.create_line(X,20,X,220,fill='black',width=1)
    canvas.create_text(X+40,190,text="重心位置%5.2f"%G,font=("Times",8))
canvas=genCanvas()
hightHumd=setHight(50,1)# ファジー集合：湿度高い
hightTemp=setHight(50,2)# ファジー集合：温度高い
lowHumd=setLow(50,1)    # ファジー集合：湿度低い
lowTemp=setLow(50,2)    # ファジー集合：温度低い

Temp=34; Humd=80        # Temp：温度，Humd：湿度

ETH=evalFuzzy(hightTemp,Temp*2)# 評価：温度高い
EHH=evalFuzzy(hightHumd,Humd)  # 評価：湿度高い
Rule1=fuzzyAnd(ETH,EHH)        # Rule1 前件部

ETL=evalFuzzy(lowTemp,Temp*2)  # 評価：温度低い
EHL=evalFuzzy(lowHumd,Humd)    # 評価：湿度低い
Rule2=fuzzyAnd(ETL,EHL)        # Rule2 前件部

Act=fuzzyOr(Rule1,Rule2)       # 後件部Max
G=Gravity(Act)                 # 重心位置計算

debug=0
if   debug==1: drawGraph2(canvas,lowTemp,hightTemp)# 温度集合表示
elif debug==2: drawGraph2(canvas,lowHumd,hightHumd)# 湿度集合表示
elif debug==3: drawGraph2(canvas,ETH,EHH)          # Rule1条件
elif debug==4: drawGraph1(canvas,Rule1)            # Rule1結果表示
elif debug==5: drawGraph2(canvas,ETL,EHL)          # Rule2条件
elif debug==6: drawGraph1(canvas,Rule2)            # Rule2結果表示
elif debug==7: drawGraph3X(canvas,Rule1,Rule2,Act) # 後件部表示
else:# 全体計算結果表示
    drawGraph1(canvas,Act)#Max集合グラフ
    drawGravity(canvas,G)
    print("重心位置",G)
